/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmeingabe.boundary;

import de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingang;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class ErgebnisGueltigerEingangDAO extends AbstractErgebnisGueltigerEingangDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(ErgebnisGueltigerEingang ergebnisGueltigerEingang){
    getEntityManager().persist(ergebnisGueltigerEingang);
  }

  public void remove(ErgebnisGueltigerEingang ergebnisGueltigerEingang){
    getEntityManager().remove(ergebnisGueltigerEingang);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                                                                    
        /**
        * Name: ErgebnisNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<ErgebnisGueltigerEingang> findByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisGueltigerEingang.findByErgebnis" ,  ergebnis  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByErgebnis( ergebnis  ));
        }
        return (java.util.List<ErgebnisGueltigerEingang>) cached;
        }
            return super.findByErgebnis( ergebnis  );
            }
                                                
        /**
        * Name: WahlAndErgebniseingangsartGebietnummerGebietsartnameNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis.wahl =?1 AND o.ergebniseingang.ergebniseingangsart=?2 AND o.ergebniseingang.wahldurchfuehrungsgebiet.nummer = ?3 AND o.ergebniseingang.wahldurchfuehrungsgebiet.gebietsart.name = ?4<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<ErgebnisGueltigerEingang> findByWahlAndErgebniseingangsartGebietnummerGebietsartname( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart,  @javax.annotation.Nonnull String gebietNummer,  @javax.annotation.Nonnull String gebietsartName) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisGueltigerEingang.findByWahlAndErgebniseingangsartGebietnummerGebietsartname" ,  wahl ,  ergebniseingangsart ,  gebietNummer ,  gebietsartName  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlAndErgebniseingangsartGebietnummerGebietsartname( wahl ,  ergebniseingangsart ,  gebietNummer ,  gebietsartName  ));
        }
        return (java.util.List<ErgebnisGueltigerEingang>) cached;
        }
            return super.findByWahlAndErgebniseingangsartGebietnummerGebietsartname( wahl ,  ergebniseingangsart ,  gebietNummer ,  gebietsartName  );
            }
                        
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}